local addonName = ...
local f = CreateFrame("Frame")

function GradientColor(statusbar)
    if (not statusbar or statusbar.disconnected) then
		return
	end

    local min, max = statusbar:GetMinMaxValues();
    if (max <= min) then
		return
	end

    local value = statusbar:GetValue()
    if ( (value < min) or (value > max) ) then
		return
	end

    value = (value - min) / (max - min);

    local r, g
    if(value > 0.5) then
        r = (1.0 - value) * 2;
        g = 1.0;
    else
        r = 1.0;
        g = value * 2;
    end
    statusbar:SetStatusBarColor(r, g, 0.0);
end

local function modstyle()
	local t = TargetFrameSpellBar
	t.timer = t:CreateFontString(nil, "OVERLAY")
	t.timer:SetFontObject("SystemFont_Shadow_Small")
	t.timer:SetShadowColor(0, 0, 0)
	t.timer:SetShadowOffset(1, -1)
	t.timer:SetPoint("RIGHT", t, -3, 0)
	t.update = .1

	t.Text:SetFont(STANDARD_TEXT_FONT, 10)
	t:ClearAllPoints()
	t:SetWidth(142)
	t:SetHeight(10)
	-- t.Text:SetPoint("TOP", t, 0, 4)
	t.Icon:Show()
	t.Icon:SetHeight(21)
	t.Icon:SetWidth(21)
	t.Icon:SetPoint("RIGHT", t, "LEFT", -10, 1)
	t.Text:ClearAllPoints()
	t.Text:SetPoint("TOPLEFT", t, "BOTTOMLEFT", 2, -5)
	t.Text:SetJustifyH("LEFT")
end

local function c_OnUpdate_Hook(self, elapsed)
    if not self.timer then return end
    if self.update and self.update < elapsed then
        if self.casting then
            self.timer:SetText(string.format("%.1f", math.max(self.maxValue - self.value, 0)))
        elseif self.channeling then
            self.timer:SetText(string.format("%.1f", math.max(self.value, 0)))
        else
            self.timer:SetText("")
        end
        self.update = .1
    else
        self.update = self.update - elapsed
    end
end


f:RegisterEvent("ADDON_LOADED")
f:SetScript(
    "OnEvent",
    function(self, event, arg1)
        if (addonName == arg1) then
            modstyle()
			TargetFrameSpellBar:HookScript("OnUpdate", function(self, elapsed) c_OnUpdate_Hook(self, elapsed) GradientColor(self) end)
			CastingBarFrame:HookScript("OnUpdate", function(self) GradientColor(self) end)

            -- TargetFrameSpellBar:SetScale(1.1)
            CastingBarFrame:SetScale(1.3)
            -- CastingBarFrame:SetSize(150, 10)
            -- CastingBarFrame:ClearAllPoints()
            -- --CastingBarFrame:SetPoint("TOP", UIParent, "BOTTOM", 0, 100)
            -- --CastingBarFrame.SetPoint = function()
            -- --end
            CastingBarFrame.Border:Hide()
            CastingBarFrame.Border:SetSize(240, 45)
            CastingBarFrame.Border:SetPoint("TOP", CastingBarFrame, 0, 15)
            CastingBarFrame.Border:SetTexture("Interface\\CastingBar\\UI-CastingBar-Border-Small")
            CastingBarFrame.Flash:SetSize(240, 45)
            CastingBarFrame.Flash:SetPoint("TOP", CastingBarFrame, 0, 15)
            CastingBarFrame.Flash:SetTexture("Interface\\CastingBar\\UI-CastingBar-Border-Small")
            CastingBarFrame.Text:SetPoint("TOP", CastingBarFrame, 0, 3)
            local function CastingBarFrame_OnUpdate_Hook(self, elapsed)
                if not self.timer then
                    return
                end
                if self.update and self.update < elapsed then
                    if self.casting then
                        -- self.timer:SetText(format("%.1f", max(self.maxValue - self.value, 0)) .. format("%.1f", self.maxValue))
                        self.timer:SetText(format("%.1f", max(self.value, 0)) .. "/" .. format("%.1f", self.maxValue))
                    elseif self.channeling then
                        self.timer:SetText(format("%.1f", max(self.value, 0)))
                    else
                        self.timer:SetText("")
                    end
                    self.update = .1
                else
                    self.update = self.update - elapsed
                end
            end
            CastingBarFrame.timer = CastingBarFrame:CreateFontString(nil)
            CastingBarFrame.timer:SetFont("Fonts\\ARIALN.ttf", 13, "THINOUTLINE")
            CastingBarFrame.timer:SetPoint("RIGHT", CastingBarFrame, "RIGHT", 36, 0)
            CastingBarFrame.update = .1
            CastingBarFrame:HookScript("OnUpdate", CastingBarFrame_OnUpdate_Hook)
            hooksecurefunc("CastingBarFrame_OnEvent", function(self, event, ...)
                local arg1 = ...
                local unit = self.unit;
                local name, text, name2, text2

                if self:IsForbidden() or not (self == TargetFrameSpellBar) or arg1 ~= unit then
                    return
                end

                if event == "UNIT_SPELLCAST_START" then
                    name, text = UnitCastingInfo(unit)
                elseif event == "UNIT_SPELLCAST_CHANNEL_START" then
                    name, text = UnitChannelInfo(unit)
                elseif event == "UNIT_SPELLCAST_INTERRUPTIBLE" then
                    name, text = UnitCastingInfo(unit)
                    name2, text2 = UnitChannelInfo(unit)
                    if self.Text and (name or name2) then
                        self.Text:SetText(text or text2)
                    end
                else
                    return
                end

                if self.BorderShield:IsShown() and name then
                    self.BorderShield:Hide()
                    if self.Text then
                        self.Text:SetText(text .. " (IMMUNE)")
                    end
                end
            end)
        end
    end
)
